/***************************************************************************
 *                          Zanoza Modeler v3.x                            *
 *      This is unpublished propietary source code of Zanoza Software.     *
 *      The copyright notice does not evidence any actual or intended      *
 *                    publication of such source code.                     *
 *                                                                         *
 *                Copyright (c) 2002-2012 Zanoza Software.                 *
 *                                                                         *
 *                        All rights reserved.                             *
 ***************************************************************************
 *--------------------------------------------------------------------------
 * @author:   Oleg M.
 *--------------------------------------------------------------------------
 * @purpose:  FNV routines
 *--------------------------------------------------------------------------
 * @histroy: 08.09.2010. Created
 */
#ifndef fnv_h_included
#define fnv_h_included
#include <zmodeler.h>

#define FNVPRIME64          1099511628211ULL
#define FNVBASE64           14695981039346656037ULL

static inline QWORD getFNV64(BYTE* pData, long nLen)
{
  QWORD hash = FNVBASE64;
  for (long n = 0; n < nLen; n++)
  {
    hash *= FNVPRIME64;
    hash ^= pData[n];
  }
  return hash;
}

#define FNVPRIME            0x01000193
#define FNVBASE             0x811C9DC5

static inline unsigned long getFNV(BYTE* pData, long nLen)
{
  unsigned long hash = FNVBASE;
  for (long n = 0; n < nLen; n++)
    hash = pData[n]^(hash*FNVPRIME);
  return hash;
}

#endif //fnv_h_included

