/***************************************************************************
 *                          Zanoza Modeler v3.x                            *
 *      This is unpublished propietary source code of Zanoza Software.     *
 *      The copyright notice does not evidence any actual or intended      *
 *                    publication of such source code.                     *
 *                                                                         *
 *                Copyright (c) 2002-2012 Zanoza Software.                 *
 *                                                                         *
 *                        All rights reserved.                             *
 ***************************************************************************
 *--------------------------------------------------------------------------
 * @author:   Oleg M.
 *--------------------------------------------------------------------------
 * @purpose:  Mafia II frameresource.bin definitions
 *--------------------------------------------------------------------------
 * @histroy: 19.09.2010. Created
 * @histroy: 07.12.2012. Remastering for ZModeler3
 */
#ifndef mafiaframenametable_h_included
#define mafiaframenametable_h_included
#include <zmodeler.h>

namespace core
{
  namespace io
  {
#pragma pack (push, 1)
    struct tNameFragment
    {
      WORD        wParent;  //points to shared string pool;
      WORD        wFirst;   //points to shared string pool;
      WORD        wSecond;  //points to shared string pool or 0xFFFF if not used;
      WORD        wHash;    //???
      WORD        wFlags;   //flag options; 0x3 for winter model;
    };
    typedef ZSequence<tNameFragment>  tNameFragmentSeq;
    
    struct tFrameNameTable
    {
      ZString           m_strPool;
      tNameFragmentSeq  m_names;
    };

#pragma pack (pop)

  };//io
};//core


#endif //mafiaframenametable_h_included

