/***************************************************************************
 *                          Zanoza Modeler v3.x                            *
 *      This is unpublished propietary source code of Zanoza Software.     *
 *      The copyright notice does not evidence any actual or intended      *
 *                    publication of such source code.                     *
 *                                                                         *
 *                Copyright (c) 2002-2012 Zanoza Software.                 *
 *                                                                         *
 *                        All rights reserved.                             *
 ***************************************************************************
 *--------------------------------------------------------------------------
 * @author:   Oleg M.
 *--------------------------------------------------------------------------
 * @purpose:  MafiaII FrameNamesTable_x.bin import routine
 *--------------------------------------------------------------------------
 * @histroy: 07.12.2012. Created
 */
#include "MafiaII.h" 
#include <helpers/serializeable.h>
#include <zmsharedclasses.h>


namespace core
{

namespace io
{

//-------------------------------------------------------
// @name : CMafiaII::importFrameNamesTable
// The import routine
// @param core::IProcParams* pParams     : 
//
// @return ZRESULT : 
//-------------------------------------------------------
ZRESULT CMafiaII::importFrameNamesTable(tFrameNameTable& table, core::io::IStream* pStream, long nID)
{
  if (!pStream)
    return ZRESULT_FALSE;

  //
  // read and dump frame names table:
  long nStringBufSize = 0;
  long nBlocks        = 0;
  pStream->read(&nStringBufSize, 4);
  table.m_strPool.bufSize(nStringBufSize);
  pStream->read((LPTSTR)table.m_strPool, nStringBufSize);
  //
  // read mapping information:
  pStream->read(&nBlocks, 4);
  table.m_names.length(nBlocks);
  pStream->read(table.m_names.getBuffer(), nBlocks*sizeof(tNameFragment));

  LPTSTR psz = (LPTSTR)table.m_strPool;
  //
  // dump:
  for (long t = 0; t < nBlocks; t++)
  {
    DEBUG_MESSAGE6("%li: %20s\t%30s\t%s\t0x%x\t0x%x\n", t,
      &psz[table.m_names[t].wParent], 
      &psz[table.m_names[t].wFirst], 
      table.m_names[t].wSecond == table.m_names[t].wFirst ? "same" : (table.m_names[t].wSecond == 0xFFFF ? "-1" : 
                      &psz[table.m_names[t].wSecond]),
      (long)table.m_names[t].wHash, (long)table.m_names[t].wFlags);
  }

  return ZRESULT_OK;
}


};//io

};//core
