/***************************************************************************
 *                          Zanoza Modeler v3.x                            *
 *      This is unpublished propietary source code of Zanoza Software.     *
 *      The copyright notice does not evidence any actual or intended      *
 *                    publication of such source code.                     *
 *                                                                         *
 *                Copyright (c) 2002-2012 Zanoza Software.                 *
 *                                                                         *
 *                        All rights reserved.                             *
 ***************************************************************************
 *--------------------------------------------------------------------------
 * @author:   Oleg M.
 *--------------------------------------------------------------------------
 * @purpose:  Mafia II common types
 *--------------------------------------------------------------------------
 * @histroy: 27.12.2012. Created
 */
#ifndef mafiacommon_h_included
#define mafiacommon_h_included
#include <zmodeler.h>

namespace core
{
  namespace io
  {

#pragma pack (push, 1)
    struct tRowMajorMarix
    {
      ZVector m_mat[3];
      inline ZVector& operator[] (const long n) { return m_mat[n]; }
    };
    typedef ZSequence<tRowMajorMarix> tRowMajorMarixSeq;

    struct tBound
    {
      float ptMin[3];
      float ptMax[3];
    };
    typedef ZSequence<tBound> tBoundSeq;

    //---------------------------------
    //    root groups information:
    //---------------------------------
    struct  tHashNamePack
    {
      QWORD     m_dwHash;
      WORD      m_wNameLen; //can be 0
      ZString   m_strName;  //can be empty
    };
    typedef ZSequence<tHashNamePack>  tHashNamePackSeq;
    void    readHashLenString(tHashNamePack* ptr, core::io::IStream* pStream);

#pragma pack (pop)

  };//io
};//core


#endif //mafiacommon_h_included

